# Library

Documenting the public user interface.

## Oceananigans.jl

```@autodocs
Modules = [Oceananigans]
Private = false
```

## Abstract operations

```@autodocs
Modules = [Oceananigans.AbstractOperations]
Private = false
```

## Advection

```@autodocs
Modules = [Oceananigans.Advection]
Private = false
```

## Architectures

```@autodocs
Modules = [Oceananigans.Architectures]
Private = false
```

## Boundary conditions

```@autodocs
Modules = [Oceananigans.BoundaryConditions]
Private = false
```

## BuoyancyModels

```@autodocs
Modules = [Oceananigans.BuoyancyModels]
Private = false
```

## Coriolis

```@autodocs
Modules = [Oceananigans.Coriolis]
Private = false
```

## Diagnostics

```@autodocs
Modules = [Oceananigans.Diagnostics]
Private = false
```

## Distributed

```@autodocs
Modules = [Oceananigans.Distributed]
Private = false
```

## Fields

```@autodocs
Modules = [Oceananigans.Fields]
Private = false
```

## Forcings

```@autodocs
Modules = [Oceananigans.Forcings]
Private = false
```

## Grids

```@autodocs
Modules = [Oceananigans.Grids]
Private = false
```

## Immersed boundaries

```@autodocs
Modules = [Oceananigans.ImmersedBoundaries]
Private = false
```

## Lagrangian particle tracking

```@autodocs
Modules = [Oceananigans.LagrangianParticleTracking]
Private = false
```

## Logger

```@autodocs
Modules = [Oceananigans.Logger]
Private = false
Pages   = ["Logger.jl"]
```

## Models

```@autodocs
Modules = [Oceananigans.Models]
Private = false
```

### Non-hydrostatic models

```@autodocs
Modules = [Oceananigans.Models.NonhydrostaticModels]
Private = false
```

### Hydrostatic free-surface models

```@autodocs
Modules = [Oceananigans.Models.HydrostaticFreeSurfaceModels]
Private = false
]
```

### Shallow-water models

```@autodocs
Modules = [Oceananigans.Models.ShallowWaterModels]
Private = false
```

## MultiRegion

```@autodocs
Modules = [Oceananigans.MultiRegion]
Private = false
```

## Operators

```@autodocs
Modules = [Oceananigans.Operators]
Private = false
]
```

## Output readers

```@autodocs
Modules = [Oceananigans.OutputReaders]
Private = false
]
```

## Output writers

```@autodocs
Modules = [Oceananigans.OutputWriters]
Private = false
]
```

## Simulations

```@autodocs
Modules = [Oceananigans.Simulations]
Private = false
```

## Solvers

```@autodocs
Modules = [Oceananigans.Solvers]
Private = false
```

## Stokes drift

```@autodocs
Modules = [Oceananigans.StokesDrift]
Private = false
```

## Time steppers

```@autodocs
Modules = [Oceananigans.TimeSteppers]
Private = false
```

## Turbulence closures

```@autodocs
Modules = [Oceananigans.TurbulenceClosures]
Private = false
```

## Utilities

```@autodocs
Modules = [Oceananigans.Utils]
Private = false
```

## Units

```@autodocs
Modules = [Oceananigans.Units]
Private = false
```
