# Model setup

This section describes all the options and features that can be used to set up a model. For 
more detailed information consult the API documentation.

Each structure covered in this section can be constructed and passed to the models' constructors. 
For examples of model construction, see the examples. The validation experiments provide more 
advanced examples.

For reference, here are all the option or keyword arguments that can be passed to the models
currently implemented in Oceananigans.jl. See the different sections on the sidebar for more 
details and examples for each keyword argument.

### `NonhydrostaticModel`

```@docs
NonhydrostaticModel
```

### `HydrostaticFreeSurfaceModel`

```@docs
HydrostaticFreeSurfaceModel
```

### `ShallowWaterModel`

```@docs
ShallowWaterModel
```
